/***************************************************************************************************/
/*script in Sql, generate by SdmCreateScript 2020(by Qihang Feng, QF255001@TERADATA.COM)     */
/*VERSION 01.10 revised on 2020-08-25                                                              */
/*Brilliance stems from wisdoms.                                                                   */
/*************Head Section**************************************************************************/
/*Script Use: Periodically load data to :t01_scrm_contact_update(SCRM联系方式变更)             */
/*Create Date:2024-02-21 19:42:12                                                                  */
/*SDM Developed By: dev                                                                            */
/*SDM Developed Date: 2024-01-12                                                                   */
/*SDM Checked By: dev                                                                              */
/*SDM Checked Date: 2024-02-21                                                                     */
/*Script Developed By: dev                                                                         */
/*Script Checked By: dev                                                                           */
/*Source table 1: p10_sa.s98_s_scrm_contact_update_af0912                                          */
/*Job Type: Inbound transform (Tier 1 to Tier 2)                                                   */
/*Target Table:t01_scrm_contact_update                                                             */
/*ETL Job Name:t01_scrm_contact_update                                                             */
/*ETL Frequency:Daily                                                                              */
/*ETL Policy:F2                                                                                    */
/********************************************************************************************/
/*******Main Section**************************************************************************/
\set ON_ERROR_STOP on
\set AUTOCOMMIT on
\timing on



/*创建临时表加载当前数据                                                                           */
CREATE TEMPORARY TABLE t01_scrm_contact_update_agi_CUR_I 
 ( LIKE :PDMDB.t01_scrm_contact_update)
ON COMMIT PRESERVE ROWS;



/*创建临时表加载不同数据                                                                           */
CREATE TEMPORARY TABLE t01_scrm_contact_update_agi_INS 
( LIKE :PDMDB.t01_scrm_contact_update)
ON COMMIT PRESERVE ROWS;

            
/*****************************************************************************************************/
/* GROUP 1:Source Table:s98_s_scrm_contact_update_af0912**********************************************/
/*****************************************************************************************************/

INSERT INTO t01_scrm_contact_update_agi_CUR_I (
            scrm_leads_id                           /*线索ID*/
           ,city_name                               /*城市*/
           ,company_name                            /*公司*/
           ,email                                   /*邮箱*/
           ,mobile_number                           /*手机号码*/
           ,full_name                               /*姓名*/
           ,prov_name                               /*省份*/
           ,create_time                             /*创建时间*/
           ,wechat_id                               /*身份-企业微信外部联系人*/
           ,update_time                             /*更新时间*/
           ,Etl_Batch_No                            /*作业批次号*/
           ,Etl_First_Dt                            /*最初入库时间*/
           ,Etl_Job                                 /*作业名称*/
           ,Etl_Proc_Dt                             /*本次入库时间*/
           ,Etl_Tx_Dt                               /*作业运行时间*/
           ,Src_Sysname                             /*来源系统*/
           ,Src_Table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.cue_id AS varchar(30))),'')         /*scrm_leads_id*/
        ,COALESCE(TRIM(CAST(p0.city_name AS varchar(50))),'')        /*city_name*/
        ,COALESCE(TRIM(CAST(p0.company_name AS varchar(50))),'')        /*company_name*/
        ,COALESCE(TRIM(CAST(p0.email AS varchar(50))),'')          /*email*/
        ,replace(COALESCE(TRIM(CAST(p0.mobile_number AS varchar(20))),''),'.0','')        /*mobile_number*/
        ,COALESCE(TRIM(CAST(p0.full_name AS varchar(20))),'')        /*full_name*/
        ,COALESCE(TRIM(CAST(p0.prov_name AS varchar(50))),'')        /*prov_name*/
        ,COALESCE(TO_TIMESTAMP(CAST(p0.create_time AS VARCHAR(19)),'YYYY-MM-DD HH24:mi:ss'),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*create_time*/
        ,COALESCE(TRIM(CAST(p0.wechat_id AS varchar(50))),'')        /*wechat_id*/
        ,COALESCE(TO_TIMESTAMP(CAST(p0.update_time AS VARCHAR(19)),'YYYY-MM-DDTHH24:mi:ss'),TO_TIMESTAMP('19000102','YYYYMMDD'))        /*update_time*/
        ,0                                                         /*Etl_Batch_No*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_First_Dt*/
        ,:ETLJOB                                                   /*Etl_Job*/
        ,current_timestamp(0)                                      /*Etl_Proc_Dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_Tx_Dt*/
        ,Substr('s98_s_scrm_contact_update_af0912',1,3)            /*Src_Sysname*/
        ,'s98_s_scrm_contact_update_af0912'                        /*Src_Table*/
        
FROM (select distinct on (cue_id,update_time) * from p10_sa.s98_s_scrm_contact_update_af0912) p0  


;



/*将不同数据插入到临时表                                                                           */
;INSERT INTO t01_scrm_contact_update_agi_INS (
         city_name                                                 /*城市*/
        ,company_name                                              /*公司*/
        ,email                                                     /*邮箱*/
        ,mobile_number                                             /*手机号码*/
        ,full_name                                                 /*姓名*/
        ,prov_name                                                 /*省份*/
        ,create_time                                               /*创建时间*/
        ,wechat_id                                                 /*身份-企业微信外部联系人*/
        ,scrm_leads_id                                             /*线索ID*/
        ,update_time                                               /*更新时间*/
        ,Etl_Batch_No                                              /*作业批次号*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        
)
    SELECT
         P1.city_name                                                 /*城市*/
        ,P1.company_name                                              /*公司*/
        ,P1.email                                                     /*邮箱*/
        ,P1.mobile_number                                             /*手机号码*/
        ,P1.full_name                                                 /*姓名*/
        ,P1.prov_name                                                 /*省份*/
        ,P1.create_time                                               /*创建时间*/
        ,P1.wechat_id                                                 /*身份-企业微信外部联系人*/
        ,P1.scrm_leads_id                                             /*线索ID*/
        ,P1.update_time                                               /*更新时间*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        
FROM t01_scrm_contact_update_agi_CUR_I P1
LEFT JOIN :PDMDB.t01_scrm_contact_update P2
ON    P1.city_name = P2.city_name
    AND P1.company_name = P2.company_name
    AND P1.email = P2.email
    AND P1.mobile_number = P2.mobile_number
    AND P1.full_name = P2.full_name
    AND P1.prov_name = P2.prov_name
    AND P1.create_time = P2.create_time
    AND P1.wechat_id = P2.wechat_id
    AND P1.scrm_leads_id = P2.scrm_leads_id
    AND P1.update_time = P2.update_time
    
WHERE  P2.city_name IS NULL
    OR P2.company_name IS NULL
    OR P2.email IS NULL
    OR P2.mobile_number IS NULL
    OR P2.full_name IS NULL
    OR P2.prov_name IS NULL
    OR P2.create_time IS NULL
    OR P2.wechat_id IS NULL
    OR P2.scrm_leads_id IS NULL
    OR P2.update_time IS NULL
    
; 
/*将新增数据插入到目标表                                                                           */
;INSERT INTO :PDMDB.t01_scrm_contact_update (
         city_name                                                 /*城市*/
        ,company_name                                              /*公司*/
        ,email                                                     /*邮箱*/
        ,mobile_number                                             /*手机号码*/
        ,full_name                                                 /*姓名*/
        ,prov_name                                                 /*省份*/
        ,create_time                                               /*创建时间*/
        ,wechat_id                                                 /*身份-企业微信外部联系人*/
        ,scrm_leads_id                                             /*线索ID*/
        ,update_time                                               /*更新时间*/
        ,Etl_Batch_No                                              /*作业批次号*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        
)
SELECT
         P1.city_name                                                 /*城市*/
        ,P1.company_name                                              /*公司*/
        ,P1.email                                                     /*邮箱*/
        ,P1.mobile_number                                             /*手机号码*/
        ,P1.full_name                                                 /*姓名*/
        ,P1.prov_name                                                 /*省份*/
        ,P1.create_time                                               /*创建时间*/
        ,P1.wechat_id                                                 /*身份-企业微信外部联系人*/
        ,P1.scrm_leads_id                                             /*线索ID*/
        ,P1.update_time                                               /*更新时间*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        
FROM t01_scrm_contact_update_agi_INS P1
ON CONFLICT ( scrm_leads_id,update_time)
DO UPDATE SET
     scrm_leads_id=excluded.scrm_leads_id
    ,update_time=excluded.update_time
    ,city_name=excluded.city_name
    ,company_name=excluded.company_name
    ,email=excluded.email
    ,mobile_number=excluded.mobile_number
    ,full_name=excluded.full_name
    ,prov_name=excluded.prov_name
    ,create_time=excluded.create_time
    ,wechat_id=excluded.wechat_id
    ,Etl_Batch_No=excluded.Etl_Batch_No
    ,Etl_First_Dt=excluded.Etl_First_Dt
    ,Etl_Job=excluded.Etl_Job
    ,Etl_Proc_Dt=excluded.Etl_Proc_Dt
    ,Etl_Tx_Dt=excluded.Etl_Tx_Dt
    ,Src_Sysname=excluded.Src_Sysname
    ,Src_Table=excluded.Src_Table
    

;
/*****程序结束退出                                               */
\q

