
DROP TABLE IF EXISTS p20_pdm.t01_scrm_contact_merge;
CREATE TABLE IF NOT EXISTS p20_pdm.t01_scrm_contact_merge (
	 merged_leads_id  varchar(30) 
	, scrm_leads_id  varchar(30) 
	, proc_date  timestamp(0) 
	, event  varchar(30) 
	, target_name  varchar(30) 
	, last_updated  timestamp(0) 
	, name  varchar(30) 
	, type  varchar(30) 
	, content_name  varchar(30) 
	, source  varchar(30) 
	, tag  varchar(30) 
	, keyword  varchar(30) 
	, attr  varchar(30) 
	, group_label  varchar(30) 
	, label  varchar(30) 
	, Etl_Batch_No  varchar(50) 
	, Etl_First_Dt  timestamp(0) 
	, Etl_Job  varchar(50) 
	, Etl_Proc_Dt  timestamp(0) 
	, Etl_Tx_Dt  timestamp(0) 
	, Src_Sysname  varchar(50) 
	, Src_Table  varchar(50) 
	,primary key( merged_leads_id,scrm_leads_id )
);

 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.merged_leads_id IS '被合并线索ID'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.scrm_leads_id IS '线索ID'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.proc_date IS '处理日期'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.event IS '处理事项'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.target_name IS '目标名称'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.last_updated IS '最后更新日期'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.name IS '名称'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.type IS '类型'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.content_name IS '目录名称'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.source IS '来源'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.tag IS '客户标签'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.keyword IS '关键词'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.attr IS '属性'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.group_label IS '标签组'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.label IS '标签'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.Etl_Batch_No IS '作业批次号'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.Etl_First_Dt IS '最初入库时间'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.Etl_Job IS '作业名称'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.Etl_Proc_Dt IS '本次入库时间'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.Etl_Tx_Dt IS '作业运行时间'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.Src_Sysname IS '来源系统'; 
 COMMENT ON COLUMN p20_pdm.t01_scrm_contact_merge.Src_Table IS '来源表'; 

COMMENT ON TABLE p20_pdm.t01_scrm_contact_merge IS 'SCRM联系方式合并';