/***************************************************************************************************/
/*script in Sql, generate by SdmCreateScript 2020(by Qihang Feng, QF255001@TERADATA.COM)     */
/*VERSION 01.10 revised on 2020-08-25                                                              */
/*Brilliance stems from wisdoms.                                                                   */
/*************Head Section**************************************************************************/
/*Script Use: Periodically load data to :t01_scrm_contact_merge(SCRM联系方式合并)             */
/*Create Date:2024-01-15 16:14:06                                                                  */
/*SDM Developed By: dev                                                                            */
/*SDM Developed Date: 2024-01-12                                                                   */
/*SDM Checked By: dev                                                                              */
/*SDM Checked Date: 2024-01-15                                                                     */
/*Script Developed By: dev                                                                         */
/*Script Checked By: dev                                                                           */
/*Source table 1: p10_sa.s98_s_scrm_contact_merge_af0912                                           */
/*Job Type: Inbound transform (Tier 1 to Tier 2)                                                   */
/*Target Table:t01_scrm_contact_merge                                                              */
/*ETL Job Name:t01_scrm_contact_merge                                                              */
/*ETL Frequency:Daily                                                                              */
/*ETL Policy:F2                                                                                    */
/********************************************************************************************/
/*******Main Section**************************************************************************/
\set ON_ERROR_STOP on
\set AUTOCOMMIT on
\timing on



/*创建临时表加载当前数据                                                                           */
CREATE TEMPORARY TABLE t01_scrm_contact_merge_agi_CUR_I 
 ( LIKE :PDMDB.t01_scrm_contact_merge)
ON COMMIT PRESERVE ROWS;



/*创建临时表加载不同数据                                                                           */
CREATE TEMPORARY TABLE t01_scrm_contact_merge_agi_INS 
( LIKE :PDMDB.t01_scrm_contact_merge)
ON COMMIT PRESERVE ROWS;

            
/*****************************************************************************************************/
/* GROUP 1:Source Table:s98_s_scrm_contact_merge_af0912***********************************************/
/*****************************************************************************************************/

INSERT INTO t01_scrm_contact_merge_agi_CUR_I (
            merged_leads_id                         /*被合并线索ID*/
           ,scrm_leads_id                           /*线索ID*/
           ,proc_date                               /*处理日期*/
           ,event                                   /*处理事项*/
           ,target_name                             /*目标名称*/
           ,last_updated                            /*最后更新日期*/
           ,name                                    /*名称*/
           ,type                                    /*类型*/
           ,content_name                            /*目录名称*/
           ,source                                  /*来源*/
           ,tag                                     /*客户标签*/
           ,keyword                                 /*关键词*/
           ,attr                                    /*属性*/
           ,group_label                             /*标签组*/
           ,label                                   /*标签*/
           ,Etl_Batch_No                            /*作业批次号*/
           ,Etl_First_Dt                            /*最初入库时间*/
           ,Etl_Job                                 /*作业名称*/
           ,Etl_Proc_Dt                             /*本次入库时间*/
           ,Etl_Tx_Dt                               /*作业运行时间*/
           ,Src_Sysname                             /*来源系统*/
           ,Src_Table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.merged_customer_id AS varchar(30))),'')        /*merged_leads_id*/
        ,COALESCE(TRIM(CAST(p0.customer_id AS varchar(30))),'')        /*scrm_leads_id*/
        ,COALESCE(TO_TIMESTAMP(CAST(p0.date AS VARCHAR(19)),'YYYY-MM-DD HH24:mi:ss'),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*proc_date*/
        ,COALESCE(TRIM(CAST(p0.event AS varchar(30))),'')          /*event*/
        ,COALESCE(TRIM(CAST(p0.target_name AS varchar(30))),'')        /*target_name*/
        ,COALESCE(TO_TIMESTAMP(CAST(p0.last_updated AS VARCHAR(19)),'YYYY-MM-DDTHH24:mi:ss'),TO_TIMESTAMP('19000102','YYYYMMDD'))        /*last_updated*/
        ,COALESCE(TRIM(CAST(p0.c_name AS varchar(30))),'')         /*name*/
        ,COALESCE(TRIM(CAST(p0.c_type AS varchar(30))),'')         /*type*/
        ,COALESCE(TRIM(CAST(p0.content_name AS varchar(30))),'')        /*content_name*/
        ,COALESCE(TRIM(CAST(p0.source AS varchar(30))),'')         /*source*/
        ,COALESCE(TRIM(CAST(p0.tag AS varchar(30))),'')            /*tag*/
        ,COALESCE(TRIM(CAST(p0.c_keyword AS varchar(30))),'')        /*keyword*/
        ,COALESCE(TRIM(CAST(p0.attr2 AS varchar(30))),'')          /*attr*/
        ,COALESCE(TRIM(CAST(p0.group_label AS varchar(30))),'')        /*group_label*/
        ,COALESCE(TRIM(CAST(p0.label AS varchar(30))),'')          /*label*/
        ,0                                                         /*Etl_Batch_No*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_First_Dt*/
        ,:ETLJOB                                                   /*Etl_Job*/
        ,current_timestamp(0)                                      /*Etl_Proc_Dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_Tx_Dt*/
        ,Substr('s98_s_scrm_contact_merge_af0912',1,3)             /*Src_Sysname*/
        ,'s98_s_scrm_contact_merge_af0912'                         /*Src_Table*/
        
FROM (select distinct on (merged_customer_id,customer_id) * from p10_sa.s98_s_scrm_contact_merge_af0912 order by merged_customer_id,customer_id,last_updated desc) p0  


;



/*将不同数据插入到临时表                                                                           */
;INSERT INTO t01_scrm_contact_merge_agi_INS (
         proc_date                                                 /*处理日期*/
        ,event                                                     /*处理事项*/
        ,target_name                                               /*目标名称*/
        ,last_updated                                              /*最后更新日期*/
        ,name                                                      /*名称*/
        ,type                                                      /*类型*/
        ,content_name                                              /*目录名称*/
        ,source                                                    /*来源*/
        ,tag                                                       /*客户标签*/
        ,keyword                                                   /*关键词*/
        ,attr                                                      /*属性*/
        ,group_label                                               /*标签组*/
        ,label                                                     /*标签*/
        ,merged_leads_id                                           /*被合并线索ID*/
        ,scrm_leads_id                                             /*线索ID*/
        ,Etl_Batch_No                                              /*作业批次号*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        
)
    SELECT
         P1.proc_date                                                 /*处理日期*/
        ,P1.event                                                     /*处理事项*/
        ,P1.target_name                                               /*目标名称*/
        ,P1.last_updated                                              /*最后更新日期*/
        ,P1.name                                                      /*名称*/
        ,P1.type                                                      /*类型*/
        ,P1.content_name                                              /*目录名称*/
        ,P1.source                                                    /*来源*/
        ,P1.tag                                                       /*客户标签*/
        ,P1.keyword                                                   /*关键词*/
        ,P1.attr                                                      /*属性*/
        ,P1.group_label                                               /*标签组*/
        ,P1.label                                                     /*标签*/
        ,P1.merged_leads_id                                           /*被合并线索ID*/
        ,P1.scrm_leads_id                                             /*线索ID*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        
FROM t01_scrm_contact_merge_agi_CUR_I P1
LEFT JOIN :PDMDB.t01_scrm_contact_merge P2
ON    P1.proc_date = P2.proc_date
    AND P1.event = P2.event
    AND P1.target_name = P2.target_name
    AND P1.last_updated = P2.last_updated
    AND P1.name = P2.name
    AND P1.type = P2.type
    AND P1.content_name = P2.content_name
    AND P1.source = P2.source
    AND P1.tag = P2.tag
    AND P1.keyword = P2.keyword
    AND P1.attr = P2.attr
    AND P1.group_label = P2.group_label
    AND P1.label = P2.label
    AND P1.merged_leads_id = P2.merged_leads_id
    AND P1.scrm_leads_id = P2.scrm_leads_id
    
WHERE  P2.proc_date IS NULL
    OR P2.event IS NULL
    OR P2.target_name IS NULL
    OR P2.last_updated IS NULL
    OR P2.name IS NULL
    OR P2.type IS NULL
    OR P2.content_name IS NULL
    OR P2.source IS NULL
    OR P2.tag IS NULL
    OR P2.keyword IS NULL
    OR P2.attr IS NULL
    OR P2.group_label IS NULL
    OR P2.label IS NULL
    OR P2.merged_leads_id IS NULL
    OR P2.scrm_leads_id IS NULL
    
; 
/*将新增数据插入到目标表                                                                           */
;INSERT INTO :PDMDB.t01_scrm_contact_merge (
         proc_date                                                 /*处理日期*/
        ,event                                                     /*处理事项*/
        ,target_name                                               /*目标名称*/
        ,last_updated                                              /*最后更新日期*/
        ,name                                                      /*名称*/
        ,type                                                      /*类型*/
        ,content_name                                              /*目录名称*/
        ,source                                                    /*来源*/
        ,tag                                                       /*客户标签*/
        ,keyword                                                   /*关键词*/
        ,attr                                                      /*属性*/
        ,group_label                                               /*标签组*/
        ,label                                                     /*标签*/
        ,merged_leads_id                                           /*被合并线索ID*/
        ,scrm_leads_id                                             /*线索ID*/
        ,Etl_Batch_No                                              /*作业批次号*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        
)
SELECT
         P1.proc_date                                                 /*处理日期*/
        ,P1.event                                                     /*处理事项*/
        ,P1.target_name                                               /*目标名称*/
        ,P1.last_updated                                              /*最后更新日期*/
        ,P1.name                                                      /*名称*/
        ,P1.type                                                      /*类型*/
        ,P1.content_name                                              /*目录名称*/
        ,P1.source                                                    /*来源*/
        ,P1.tag                                                       /*客户标签*/
        ,P1.keyword                                                   /*关键词*/
        ,P1.attr                                                      /*属性*/
        ,P1.group_label                                               /*标签组*/
        ,P1.label                                                     /*标签*/
        ,P1.merged_leads_id                                           /*被合并线索ID*/
        ,P1.scrm_leads_id                                             /*线索ID*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        
FROM t01_scrm_contact_merge_agi_INS P1
ON CONFLICT ( merged_leads_id,scrm_leads_id)
DO UPDATE SET
     merged_leads_id=excluded.merged_leads_id
    ,scrm_leads_id=excluded.scrm_leads_id
    ,proc_date=excluded.proc_date
    ,event=excluded.event
    ,target_name=excluded.target_name
    ,last_updated=excluded.last_updated
    ,name=excluded.name
    ,type=excluded.type
    ,content_name=excluded.content_name
    ,source=excluded.source
    ,tag=excluded.tag
    ,keyword=excluded.keyword
    ,attr=excluded.attr
    ,group_label=excluded.group_label
    ,label=excluded.label
    ,Etl_Batch_No=excluded.Etl_Batch_No
    ,Etl_First_Dt=excluded.Etl_First_Dt
    ,Etl_Job=excluded.Etl_Job
    ,Etl_Proc_Dt=excluded.Etl_Proc_Dt
    ,Etl_Tx_Dt=excluded.Etl_Tx_Dt
    ,Src_Sysname=excluded.Src_Sysname
    ,Src_Table=excluded.Src_Table
    

;
/*****程序结束退出                                               */
\q

